# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Prospecting do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :ActiveYN,
    :BccMeYN,
    :ClientActivatedYN,
    :ConciergeNotificationsYN,
    :ConciergeYN,
    :ContactKeyNumeric,
    :OwnerMemberKeyNumeric,
    :ProspectingKeyNumeric,
    :SavedSearchKeyNumeric,
    :BccEmailList,
    :CcEmailList,
    :ContactKey,
    :DisplayTemplateID,
    :MessageNew,
    :MessageRevise,
    :MessageUpdate,
    :OwnerMemberID,
    :OwnerMemberKey,
    :ProspectingKey,
    :SavedSearchKey,
    :Subject,
    :ToEmailList,
    :DailySchedule,
    :Languages,
    :ReasonActiveOrDisabled,
    :ScheduleType,
    :LastNewChangedTimestamp,
    :LastViewedTimestamp,
    :ModificationTimestamp,
    :NextSendTimestamp,
    :Contact,
    :OwnerMember,
    :SavedSearch
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :ActiveYN => boolean() | nil,
    :BccMeYN => boolean() | nil,
    :ClientActivatedYN => boolean() | nil,
    :ConciergeNotificationsYN => boolean() | nil,
    :ConciergeYN => boolean() | nil,
    :ContactKeyNumeric => float() | nil,
    :OwnerMemberKeyNumeric => float() | nil,
    :ProspectingKeyNumeric => float() | nil,
    :SavedSearchKeyNumeric => float() | nil,
    :BccEmailList => String.t | nil,
    :CcEmailList => String.t | nil,
    :ContactKey => String.t | nil,
    :DisplayTemplateID => String.t | nil,
    :MessageNew => String.t | nil,
    :MessageRevise => String.t | nil,
    :MessageUpdate => String.t | nil,
    :OwnerMemberID => String.t | nil,
    :OwnerMemberKey => String.t | nil,
    :ProspectingKey => String.t | nil,
    :SavedSearchKey => String.t | nil,
    :Subject => String.t | nil,
    :ToEmailList => String.t | nil,
    :DailySchedule => [String.t] | nil,
    :Languages => String.t | nil,
    :ReasonActiveOrDisabled => String.t | nil,
    :ScheduleType => String.t | nil,
    :LastNewChangedTimestamp => Date.t | nil,
    :LastViewedTimestamp => Date.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :NextSendTimestamp => Date.t | nil,
    :Contact => FoyerAPI.Model.Contacts.t | nil,
    :OwnerMember => FoyerAPI.Model.Member.t | nil,
    :SavedSearch => FoyerAPI.Model.SavedSearch.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Prospecting do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:LastNewChangedTimestamp, :date, nil, options)
    |> deserialize(:LastViewedTimestamp, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:NextSendTimestamp, :date, nil, options)
    |> deserialize(:Contact, :struct, FoyerAPI.Model.Contacts, options)
    |> deserialize(:OwnerMember, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:SavedSearch, :struct, FoyerAPI.Model.SavedSearch, options)
  end
end

